﻿Imports System.Drawing.Drawing2D

Public Partial Class CropImage
       
        Private _CropRectangle As CropRectangle
        Private _ZoomFactor As Double
     
        Public Sub New()
      
           Me.InitializeComponent()
           
			_CropRectangle = New CropRectangle
			
       End Sub
      
       Private Sub PictureBox1_MouseDown( ByVal sender As System.Object,  ByVal e As System.Windows.Forms.MouseEventArgs) Handles PictureBox1.MouseDown
           _CropRectangle.CropX = e.X
           _CropRectangle.CropY = e.Y
           _CropRectangle.CropX2 = e.X
           _CropRectangle.CropY2 = e.Y
           _CropRectangle.Initialized = True
       End Sub
    
       Private Sub PictureBox1_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PictureBox1.MouseMove
           If _CropRectangle.Initialized = True
               _CropRectangle.CropX2 = e.X
               _CropRectangle.CropY2 = e.Y
               _CropRectangle.Draw(Me.PictureBox1)
           end if
       End Sub
    
       Private Sub PictureBox1_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PictureBox1.MouseUp
           _CropRectangle.Initialized = False
           _CropRectangle.DrawCroppedImage(PictureBox1, PictureBox2)
       End Sub
    
    
       Private Class CropRectangle
           Private _CropPen As Pen
    
           Public Sub New
               _cropPen = New Pen(Color.green, 1)    
               _cropPen.DashStyle = DashStyle.Dot      
           End Sub
    
           Public Property Initialized As Boolean = False
           Public Property CropX As Integer
           Public Property CropY As Integer
           Public Property CropX2 As Integer
           Public Property CropY2 As Integer
           Public Property ZoomFactor As Double
    
           Public readonly Property CropPen As Pen
               Get
                   Return _CropPen
               End Get
          End Property
   
          Public sub DrawCroppedImage(ByVal PictureBox1 As PictureBox, Byref PictureBox2 As PictureBox)
              Dim bmp As New Bitmap(Convert.ToInt32((_CropX2 - _CropX)), Convert.ToInt32((_CropY2 - _CropY)))              
              Dim g = Graphics.FromImage(bmp)
              g.DrawImage(PictureBox1.Image,0,0, New Rectangle(_cropx, _cropy, (_cropx2 -_cropx), (CropY2 - _cropy)), GraphicsUnit.Pixel)
              PictureBox2.Image = bmp
          End Sub
   
          Public sub Draw(ByRef PictureBox1 As PictureBox)
              PictureBox1.Refresh()
              Dim g = PictureBox1.CreateGraphics
              g.DrawRectangle(_cropPen,_cropx, _cropy, _cropx2 -_cropx, CropY2 - _cropy)
          End Sub
         
      End Class
         
  End Class
